import './es.array.includes-4168e520.js';
import { _ as _objectSpread2, s as size, c as classAppend, a as classRemove, v as variant, b as status, C as Classy, r as registerComponent } from './index-089cc08a.js';
import { defineComponent, computed, inject, openBlock, createBlock, renderSlot } from 'vue';
import merge from 'lodash.merge';
import './export-727d3f8d.js';
import '@babel/runtime/helpers/typeof';
import 'core-js/modules/es.symbol.js';
import 'core-js/modules/es.array.filter.js';
import 'core-js/modules/es.array.for-each.js';
import 'core-js/modules/es.object.get-own-property-descriptor.js';
import 'core-js/modules/es.object.get-own-property-descriptors.js';
import 'core-js/modules/es.object.keys.js';
import 'core-js/modules/web.dom-collections.for-each.js';
import '@babel/runtime/helpers/esm/defineProperty';
import 'clsx';
import 'twind';

const buttonDefault = "inline-flex items-center border-2 font-medium rounded-md leading-6 focus:relative focus:z-20 focus:ring-opacity-60 focus:outline-none focus:ring-2 focus:ring-offset-2";
// eslint-disable-next-line @typescript-eslint/explicit-module-boundary-types, @typescript-eslint/no-explicit-any
const Theme = (userTheme) => {
    return merge({
        primary: `${buttonDefault} border-transparent shadow-sm text-white dark:ring-offset-blue-900 ring-offset-blue-50 bg-blue-600 hover:bg-blue-700 focus:ring-blue-500`,
        secondary: `${buttonDefault} border-transparent shadow-sm text-white dark:ring-offset-gray-900 ring-offset-gray-50 bg-gray-600 hover:bg-gray-700 focus:ring-gray-500`,
        outline: `${buttonDefault} text-gray-700 dark:text-gray-100 border-gray-400 dark:border-gray-600 focus:border-gray-500 ring-offset-gray-50 dark:ring-offset-gray-800 hover:bg-gray-500 hover:bg-opacity-10 hover:dark:bg-gray-200 hover:dark:bg-opacity-10 focus:bg-gray-900 focus:dark:bg-gray-100 focus:bg-opacity-10 focus:dark:bg-opacity-20 focus:ring-gray-400 px-3.5 py-1.5`,
        success: `${buttonDefault} border-transparent shadow-sm text-white dark:ring-offset-green-900 ring-offset-green-50 bg-green-600 hover:bg-green-700 focus:ring-green-500`,
        danger: `${buttonDefault} border-transparent shadow-sm text-white dark:ring-offset-red-900 ring-offset-red-50 bg-red-600 hover:bg-red-700 focus:ring-red-500`,
        warn: `${buttonDefault} border-transparent shadow-sm text-white dark:ring-offset-yellow-900 ring-offset-yellow-50 bg-yellow-600 hover:bg-yellow-700 focus:ring-yellow-500`,
        disabled: `${buttonDefault} border-transparent bg-gray-100 dark:bg-gray-700 cursor-not-allowed pointer-events-none`,
        size: {
            xs: "px-1 leading-5 text-xs",
            sm: "px-2.5 py-0.5 py text-sm",
            md: "px-3.5 py-1.5",
            lg: "px-5 py-2.5 text-lg",
            xl: "px-6 py-4 text-xl",
        },
    }, userTheme ? userTheme.ZButton : null);
};

var script = defineComponent({
  name: "Button",
  props: _objectSpread2(_objectSpread2(_objectSpread2(_objectSpread2(_objectSpread2({}, classAppend()), classRemove()), variant({
    default: "primary"
  })), status({
    default: "default",
    validator: function validator(v) {
      return ["loading", "default"].includes(v);
    }
  })), size({
    default: "md",
    validator: function validator(v) {
      return ["xs", "sm", "md", "lg", "xl"].includes(v);
    }
  })),
  setup: function setup(props) {
    var _computed = computed(function () {
      return Theme(inject("userTheme", {}));
    }),
        theme = _computed.value;

    var classes = computed(function () {
      return new Classy("italic").append(theme[props.variant]).append(theme.size[props.size]).append(props.classAppend).remove(props.classRemove).twind(inject("twindEnable", true)).val();
    });
    return {
      classes: classes
    };
  }
});

function render(_ctx, _cache, $props, $setup, $data, $options) {
  return openBlock(), createBlock("button", {
    class: _ctx.classes
  }, [renderSlot(_ctx.$slots, "default")], 2);
}

script.render = render;

const ButtonPlugin = {
    // eslint-disable-next-line @typescript-eslint/explicit-module-boundary-types
    install: (vue) => {
        registerComponent(vue, script);
    }
};

export default script;
export { ButtonPlugin };
